# Generated by Django 5.1.2 on 2024-10-09 10:15

from django.db import migrations
from typing import TYPE_CHECKING

from strategy_field.utils import fqn

from hope_flex_fields.utils import get_kwargs_from_field_class, get_default_attrs

if TYPE_CHECKING:
    from hope_flex_fields.models import FieldDefinition


def create_default_fields(apps, schema_editor):
    from hope_flex_fields.registry import field_registry

    fd: "FieldDefinition" = apps.get_model("hope_flex_fields", "FieldDefinition")

    for fld in field_registry:
        name = fld.__name__
        fd.objects.get_or_create(name=name,
                                 field_type=fqn(fld),
                                 defaults={"attrs": get_kwargs_from_field_class(fld, get_default_attrs())}
                                 )


def remove_default_fields(apps, schema_editor):
    pass


class Migration(migrations.Migration):
    dependencies = [
        (
            "hope_flex_fields",
            "0006_alter_datachecker_id_alter_datacheckerfieldset_id_and_more",
        ),
    ]

    operations = [
        migrations.RunPython(create_default_fields, remove_default_fields),
    ]
